#include <bits/stdc++.h>
#define all(x) begin(x), end(x)
using namespace std;

int n;
vector<pair<int, int>> swaps;

int main() {
    freopen("input.txt", "r", stdin);
    int m;
    int64_t k;
    cin >> n >> m >> k;
    swaps.resize(m);
    for (auto &s: swaps) {
        cin >> s.first >> s.second;
        --s.first;
        --s.second;
    }
    vector<int> orig(n);
    iota(all(orig), 0);
    vector<int> cur = orig;
    for (const auto &s: swaps)
        swap(cur[s.first], cur[s.second]);
    vector<vector<int>> cycles;
    vector<pair<int, int>> mypos(n, pair<int, int>(-1, -1));
    for (int i = 0; i < n; ++i) if (mypos[i].first < 0) {
        cycles.emplace_back(vector<int>());
        cycles.back().emplace_back(i);
        mypos[i].first = int(cycles.size()) - 1;
        mypos[i].second = int(cycles.back().size()) - 1;
        for (int j = cur[i]; j != i; j = cur[j]) {
            assert(mypos[j].first < 0);
            cycles.back().emplace_back(j);
            mypos[j].first = int(cycles.size()) - 1;
            mypos[j].second = int(cycles.back().size()) - 1;
        }
    }
    int64_t ncyc = k / m;
    for (int i = 0; i < n; ++i) {
        const auto &pos = mypos[i];
        const auto &cyc = cycles[pos.first];
        cur[i] = cyc[(pos.second + ncyc) % cyc.size()];
    }
    int left = k % m;
    for (int i = 0; i < left; ++i) {
        const auto &s = swaps[i];
        swap(cur[s.first], cur[s.second]);
    }
    for (int v: cur)
        cout << (v + 1) << ' ';
    cout << '\n';
}
