#include <cstdio>
#include <cstdint>
#include <cmath>

using namespace std;
/*
int main() {
    uint64_t amount = 0;
    cin >> amount;
    uint64_t *nums = new uint64_t[amount];
    vector<bool> primes(200001, true);
    primes[1] = false;
    for (uint64_t i = 2; i < 200001; ++i) {
        if (primes[i]) {
            for (uint64_t j = i * i; j < 200001; j = j + i) {
                primes[j] = false;
            }
        }
    }
    uint64_t res = 0;
    //vector<map<uint64_t, uint64_t> > powers(200001);
    map<uint64_t, map<uint64_t, uint64_t> > fact;
    for (uint64_t i = 0; i < amount; ++i) {
        cin >> nums[i];
        uint64_t tmp = nums[i];
        uint64_t up_b = static_cast<uint64_t>(sqrt(nums[i])) + 1;
        for (uint64_t m = 2; m < up_b; ++m) {
            if (primes[m]) {
                uint64_t pow = 0;
                while (tmp % m == 0) {
                    //++powers[m][i];
                    ++fact[i][m];
                    tmp /= m;
                    ++pow;
                    //cout << nums[i] << ' ' << m << '\n';
                }
            }
        }
        for (uint64_t l = 0; l < i; ++l) {
                bool ok = true;
                map<uint64_t, uint64_t>::iterator it1 = fact[l].begin();
                map<uint64_t, uint64_t>::iterator it2 = fact[i].begin();
                map<uint64_t, uint64_t> r;
                while (it1 != fact[l].end()) {
                    r[(*it1).first] = (*it1).second;
                    ++it1;
                }
                while (it2 != fact[i].end()) {
                    r[(*it2).first] += (*it2).second;
                    ++it2;
                }
                 map<uint64_t, uint64_t>::iterator it = r.begin();
                while (it != r.end()) {
                    if ((*it).second % 2 != 0) {
                        ok = false;
                    }
                    ++it;
                }
                if (ok) {
                        //cout << l << ' ' << i << '\n';
                    ++res;
                }
        }
    }
    cout << res;
    return 0;
}*/

int main() {
    uint64_t amount = 0;
    scanf("%llu", &amount);
    uint64_t *nums = new uint64_t[amount];
    uint64_t res = 0;
    for (uint64_t i = 0; i < amount; ++i) {
        scanf("%llu", nums + i);
        for (uint64_t k = 0; k < i; ++k) {
            uint64_t r = nums[i] * nums[k];
            uint64_t val1 = static_cast<uint64_t>(sqrt(r));
            uint64_t val2 = static_cast<uint64_t>(sqrt(r)) + 1;
            if (val1 * val1 == r || val2 * val2 == r) {
                ++res;
            }
        }
    }
    printf("%llu", res);
    return 0;
}

