#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <cstring>
#include <ctime>
#include <cassert>
#include <memory.h>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <complex>
#include <bitset>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e5);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-7;
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)0)++)

int lp[200010];
vector<int> pr;

void sieve()
{
	for (int i = 2; i < 200010; i++)
	{
		if (lp[i] == 0)
		{
			lp[i] = i;
			pr.push_back(i);
		}
		for (int j = 0; j < (int)pr.size() && pr[j] <= lp[i] && (int64)i * pr[j] < 200010; j++)
			lp[i * pr[j]] = pr[j];
	}
}

map<vector<int>, int> ctr;

int n;
int a[200010];

void push(int d)
{
	vector<int> tt;
	while (d > 1)
	{
		int p = lp[d];
		int ct = 0;
		while (lp[d] == p)
		{
			d /= p;
			ct++;
		}
		if(ct & 1)
			tt.push_back(p);
	}
	ctr[tt]++;
}

void solve()
{
	sieve();
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		push(a[i]);
	}
	int64 ans = 0;
	for (auto &it : ctr)
		ans += (int64)(it.second) * (it.second - 1) / 2;
	cout << ans;
}

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
#endif

	solve();

	return 0;
}