#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <cstring>
#include <ctime>
#include <cassert>
#include <memory.h>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <complex>
#include <bitset>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e5);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-7;
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)0)++)

int n, m;
vector<string> lines;
vector<vector<string> > a;
vector<int> len;

void trim(string &s)
{
	int l = 0;
	int r = (int)s.size();
	if (s[l] == '"' && s[r - 1] == '"')
	{
		l++;
		r--;
	}
	int pos = 0;
	for (int i = l; i < r; i++)
	{
		if (i != l && s[i] == '"' && s[i - 1] == '"')
			continue;
		s[pos] = s[i];
		pos++;
	}
	s.resize(pos);
}

void solve()
{
	string ts, tt;
	while (getline(cin, ts))
	{
		if (ts == "")
			continue;
		lines.push_back(ts);
		a.push_back(vector<string>());
		tt = "";
		int bal = 0;
		for (int i = 0; i < (int)ts.size(); i++)
		{
			if (ts[i] == '"')
			{
				if (tt == "" || tt[0] == '"')
					bal ^= 1;
			}
			if (ts[i] == ',' && !bal)
			{
				a.back().push_back(tt);
				tt = "";
			}
			else
			{
				tt += ts[i];
			}
		}
		a.back().push_back(tt);
		m = max(m, (int)a.back().size());
	}
	n = (int)lines.size();
	len.assign(m, 0);
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (j == (int)a[i].size())
				a[i].push_back("");
			trim(a[i][j]);
			len[j] = max(len[j], (int)a[i][j].size());
		}
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (j)
				cout << '|';
			cout << a[i][j];
			int dt = len[j] - (int)a[i][j].size();
			for (int k = 0; k < dt; k++)
				cout << ' ';
		}
		if (i != n - 1)
			cout << '\n';
	}
}

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
#endif

	solve();

	return 0;
}