#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <cstring>
#include <ctime>
#include <cassert>
#include <memory.h>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <complex>
#include <bitset>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e5);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-7;
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)0)++)

int n, m;
int64 k;
int a[100010];
int b[100010];
int pp[1010];
int u[1010];

void solve()
{
	cin >> n >> m >> k;
	for (int i = 0; i < n; i++)
		pp[i] = i;
	for (int i = 0; i < m; i++)
	{
		cin >> a[i] >> b[i];
		a[i]--;
		b[i]--;
		swap(pp[a[i]], pp[b[i]]);
	}
	int64 ct = (k / m) - 1;
	vector<int> tmp;
	vector<int> vals;
	for (int i = 0; i < n; i++)
	{
		if(u[i])
			continue;
		tmp.clear();
		vals.clear();
		int pos = i;
		while (!u[pos])
		{
			tmp.push_back(pos);
			vals.push_back(pp[pos]);
			u[pos] = 1;
			pos = pp[pos];
		}
		int sz = (int)tmp.size();
		int sh = ((ct % sz) + sz) % sz;
		for (int j = 0; j < sz; j++)
		{
			int nj = (j + sh + sz) % sz;
			pp[tmp[j]] = vals[nj];
		}
	}
    int ost = k % m;
	for (int i = 0; i < ost; i++)
		swap(pp[a[i]], pp[b[i]]);
	for (int i = 0; i < n; i++)
		cout << pp[i] + 1 << ' ';
}

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
#endif

	solve();

	return 0;
}