#include <iostream>
#include <string>
#include <map>
using namespace std;

bool not_prime(int n)
{
	int ans = 0;
	for (int i = 2; i * i <= n; ++i)
		if (n % i == 0) return 1;
	return 0;
}

int primes[17900];

int S[200000];
int res[200001];

int main()
{
	int d = 0;
	for (int k = 2; k <= 200000; ++k)
		if (!not_prime(k))
		{
			primes[d] = k;
			++d;
		}

	int N;
	cin >> N;
	for (int i = 0; i < N; ++i)
	{
		cin >> S[i];
		for (int j = 0; primes[j] * primes[j] <= S[i]; ++j)
		{
			while (S[i] % (primes[j] * primes[j]) == 0)
				S[i] /= primes[j] * primes[j];
		}
		++res[S[i]];
	}
	long ans = 0;
	for (int i = 0; i <= 200000; ++i)
		if (res[i] > 1)
		ans += res[i] * (res[i] - 1) / 2;

	cout << ans << endl;

	return 0;

}