#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <memory.h>
#include <fstream>
#include <sstream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long int64;

vector <int> get_divs(int x)
{
	vector <int> res;
	for (int i = 1; i * i <= x; i++)
	{
		if (x % i == 0)
		{
			res.push_back(i);
			if (x / i != i)
			{
				res.push_back(x / i);
			}
		}
	}
	return res;
}

bool check(int a, int b, int x)
{
	if (b % 10 >= x || b / 10 >= x)
	{
		return false;
	}
	int c = a % x + (a / x) % x * 10;
	return c == b;
}

void solve()
{
	int a, b;
	scanf ("%d%d", &a, &b);
	int x = a - b % 10;
	vector <int> d = get_divs(x);
	vector <int> res;
	for (int i = 0; i < (int)d.size(); i++)
	{
		if (check(a, b, d[i]))
		{
			res.push_back(d[i]);
		}
	}
	if (res.empty())
	{
		printf("-1\n");
	}
	else
	{
		for (int i = 0; i < (int)res.size(); i++)
		{
			printf("%d ", res[i]);
		}
	}
}

int main()
{
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

	srand(33);
	solve();

	return 0;
}