#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <memory.h>
#include <fstream>
#include <sstream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long int64;
typedef pair<int, int> pii;

const int MAXN = 1005;
const int LOG = 60;

int n, m;
int64 k, x;
pii r[MAXN];
int p[MAXN], pos[MAXN][LOG];

void init()
{
	scanf ("%d%d%lld", &n, &m, &k);
	for (int i = 1; i <= m; i++)
	{
		scanf ("%d%d", &r[i].first, &r[i].second);
	}
}

void solve()
{
	init();
	for (int i = 1; i <= n; i++)
	{
		p[i] = i;
	}
	for (int i = 1; i <= m; i++)
	{
		swap(p[r[i].first], p[r[i].second]);
	}
	for (int i = 1; i <= n; i++)
	{
		pos[p[i]][0] = i;
	}
	for (int j = 1; j < LOG; j++)
	{
		for (int i = 1; i <= n; i++)
		{
			pos[i][j] = pos[pos[i][j - 1]][j - 1];
		}
	}
	x = k / m;
	for (int i = 1; i <= n; i++)
	{
		int p = i;
		for (int j = 0; j < LOG; j++)
		{
			if (x & (1LL << j))
			{
				p = pos[p][j];
			}
		}
		::p[p] = i;
	}
	/*for (int i = 1; i <= n; i++)
	{
		printf("%d ", p[i]);
	}
	printf("\n");*/
	x *= m;
	while (++x <= k)
	{
		int num = (x - 1) % m + 1;
		swap(p[r[num].first], p[r[num].second]);
	}
	for (int i = 1; i <= n ;i++)
	{
		printf("%d ", p[i]);
	}
}

int main()
{
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

	srand(33);
	solve();

	return 0;
}