#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <memory.h>
#include <fstream>
#include <sstream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long int64;
typedef pair<int, int> pii;

int n;
set <pii> s;
int len;

void init()
{
	scanf ("%d", &n);
}

void del(int a, int b)
{
	s.erase(pii(a, b));
	len -= b - a + 1;
}

void add(int a, int b)
{
	auto it = s.upper_bound(pii(b + 1, 0));
	if (it != s.end() && it->first == b + 1)
	{
		b = it->second;
		len -= it->second - it->first + 1;
		s.erase(it);
	}
	it = s.upper_bound(pii(b + 1, 0));
	if (it != s.begin())
	{
		--it;
		if (it->second == a - 1)
		{
			a = it->first;
			len -= it->second - it->first + 1;
			s.erase(it);
		}
	}
	s.insert(pii(a, b));
	len += b - a + 1;
}

void print()
{
	for (auto it = s.begin(); it != s.end(); it++)
	{
		printf("%d-%d\n", it->first, it->second);
	}
}

void solve()
{
	init();
	for (int i = 1; i <= n; i++)
	{
		char com[10]; int pos;
		scanf ("%s%d", &com, &pos);
		if (com[0] == 'a')
		{
			auto it = s.upper_bound(pii(pos + 1, 0));
			if (it == s.begin())
			{
				add(pos, pos);
			}
			else
			{
				--it;
				if (it->second >= pos)
				{
					int a = it->first;
					int b = it->second;
					del(a, b);
					if (pos > a)
					{
						add(a, pos - 1);
					}
					add(b + 1, b + 1);
				}
				else
				{
					add(pos, pos);
				}
			}
		}
		else
		{
			auto it = s.upper_bound(pii(pos, 0));
			if (it != s.begin())
			{
				--it;
				if (!(it->first <= pos && it->second >= pos))
				{
					++it;
				}
			}
			int a = it->first;
			int b = it->second;
			del(a, b);
			if (a <= pos && pos <= b)
			{
				if (a < pos)
				{
					add(a, pos - 1);
				}
				if (b > pos)
				{
					add(pos + 1, b);
				}
			}
			else
			{
				if (a < b)
				{
					add(a + 1, b);
				}
				add(pos, a - 1);
			}
		}
		//print();
		printf("%d\n", len);
	}
}

int main()
{
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

	srand(33);
	solve();

	return 0;
}