#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cassert>
#include <sstream>
#include <cstdio>
#include <string>
#include <cmath>
using namespace std;
#define Sz(x) ((int)((x).size()))

bool mycmp(int a, int b) {
	assert(abs(a % 2) == 1 && abs(b % 2) == 1);
	string sa = to_string(a);
	string sb = to_string(b);
	if (Sz(sa) != Sz(sb))
		return Sz(sa) < Sz(sb);
	return a < b;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int x; cin >> x;
	assert(x % 2 == 0);
	int a = x + 1;
	int b = x - 1;
	if (mycmp(a, b))
		cout << a << endl;
	else
		cout << b << endl;

	return 0;
}