#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cassert>
#include <sstream>
#include <cstdio>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <functional>
#include <map>
#include <set>
#include <sstream>
#include <utility>
#include <cstring>
#include <cstdlib>
#include <unordered_set>
using namespace std;
#define Sz(x) ((int)((x).size()))
typedef long long int64;
typedef pair<int, int> pii;

#ifdef _DEBUG
const int maxp = 1000;
#else
const int maxp = 1000000000;
#endif

int a, b;
int b0, b1;
vector<int> ans;
vector<int> ps;

void go(int val, int pid) {
	if (pid == Sz(ps)) {
		if (a % val == b0 && a / val % val == b1)
			ans.push_back(val);
		return;
	}

	go(val, pid + 1);
	while (val % ps[pid] == 0) {
		val /= ps[pid];
		go(val, pid + 1);
	}
}

int main() {
//#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
//#endif

#if 0
	std::vector<int64> primes(1, 2);
	for (int64 t = 3; t <= maxp; t += 2) {
		bool ok = true;
		for (auto j : primes) {
			if (j * j > t)
				break;
			if (t % j == 0) {
				ok = false;
				break;
			}
		}
		if (ok)
			primes.push_back(t);
	}
#endif

	cin >> a >> b;

	assert(10 <= b && b < 100);
	b0 = b % 10;
	b1 = b / 10;

	int t = a - b0;
	if (t > 0) {
		int tt = t;
		for (int i = 2; i * i <= tt; ++i) {
			if (tt % i == 0) {
				ps.push_back(i);
				while (tt % i == 0)
					tt /= i;
			}
		}
		if (tt > 1)
			ps.push_back(tt);
		go(t, 0);
	}

#if 0
	for (int i = 2; i < 100; ++i) {
		if (a % i != b0)
			continue;
		if (a / i % i != b1)
			continue;
		cout << i << ' ';
	}
#endif

	for (int i : ans)
		cout << i << ' ';
	cout << endl;


	return 0;
}