#include <iostream>
#include <vector>
using namespace std;

vector <int> prime;
bool is_found[200001] = { 0 };
int where_it_goes[200001] = { 0 };
int counter[200001] = { 0 };

int find_less(int x)
{
	int to_return = 1;
	for (int j = 0; j < prime.size(); j++)
	{
		if (x == 1)
			break;

		if (x % prime[j] == 0)
		{
			while (x % (prime[j] * prime[j]) == 0)
			{
				x = x / (prime[j] * prime[j]);
			}
			if (x % prime[j] == 0)
			{
				to_return = to_return * prime[j];
				x = x / prime[j];
			}
		}
	}
	return to_return;
}

int main()
{
	//find prime numbers
	for (int i = 2; i < 450; i++)
	{
		bool is_found_ = false;
		for (int j = 0; j < prime.size(); j++)
		{
			if (i % prime[j] == 0)
			{
				is_found_ = true;
				break;
			}
		}
		if (!is_found_)
		{
			prime.push_back(i);
		}
	}

	
	int N;
	cin >> N;
	for (int i = 0; i < N; i++)
	{
		int temp;
		cin >> temp;
		if (!is_found[temp])
		{
			is_found[temp] = true;
			int theLessOne = find_less(temp);
			where_it_goes[temp] = theLessOne;
			counter[theLessOne]++;
		}
		else
		{
			int theLessOne = where_it_goes[temp];
			counter[theLessOne]++;
		}
	}

	long long int total = 0;
	for (int i = 1; i <= 200000; i++)
	{
		if (counter[i] > 1)
		{
			total = total + counter[i] * (counter[i] - 1) / 2;
		}
	}
	cout << total << endl;

    return 0;
}

