#define _CRT_SECURE_NO_WARNINGS

#include <cstdlib>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iostream>

using namespace std;

typedef long long ll;

set < int > S;
vector <pair<int, int> > ps;
vector < int > ans_stup;
ll a, b;

void rec(int pos, int ch)
{
	if (pos >= ps.size())
		return;
	rec(pos + 1, ch);
	for (int k = 0; k < ps[pos].second; k++)
	{
		ch *= ps[pos].first;
		S.insert(ch);
		rec(pos + 1, ch);
	}
}

void stupid()
{
	for (ll i = max(b % 10, b / 10) + 1; i <= (a - (b % 10)) / (b / 10); i++) {
		if ((a % (i*i)) == ((b / 10)*i + (b % 10))) {
			ans_stup.push_back(i);
		}
	}
}

int main()
{
#ifdef XXX
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	cin >> a >> b;
	
	int cur = a - b % 10;
	
	for (int i = 2; i * i <= cur; i++)
	{
		int res = 0;
		while (cur % i == 0)
		{
			res++;
			cur /= i;
		}
		if (res)
			ps.push_back(make_pair(i, res));
	}
	if (cur > 1)
		ps.push_back(make_pair(cur, 1));

	rec(0, 1);
	
	vector <int> ans;
	int b0 = b % 10, b1 = b / 10;
	for (auto x : S)
	{
		if (x > max(b0, b1))
		{
			if ((a % (x*x)) == (b1*x + b0)) {
				ans.push_back(x);
			}
		}
	}

	if (ans.size() == 0)
		cout << -1;
	
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i] << " ";

	return 0;
}