#include <iostream>
#include <vector>
#include <map>
#include <cstdio>
using namespace std;

map<vector<int>, long long> Map;
vector<vector<int> > Cnt;

void f(int u, int cur)
{
    int n = cur;
    vector<int> v;
    for(int i = 2; i * i <= cur; ++i)
    {
        int y = 0;
        while(n % i == 0)
        {
            y++;
            n/=i;
        }
        if (y % 2)
        {
            v.push_back(i);
        }
    }
    if (n != 1)
    {
        v.push_back(n);
    }
    Cnt[u] = v;
    Map[v]++;
}


int main()
{
    freopen("input.txt", "r", stdin);
    int N;
    cin>>N;
    vector<int> A(N);
    Cnt.resize(N);
    for(int i = 0; i < N; ++i)
    {
        cin>>A[i];
        //cout<<A[i]<<endl;
        f(i, A[i]);
    }

    long long cnt = 0;
    for(int i = 0; i < N;++i)
    {
        cnt += Map[Cnt[i]];
    }
    cnt -= N;
    cnt /=2;
    cout<<cnt<<endl;

}
