#include <iostream>
#include <vector>
#include <map>
#include <cstdio>
#include <cstdlib>
//#define int long long int

using namespace std;

vector<vector<pair<int, int> > > A;
vector<int> zar;
vector<int> used;
vector<int> xo;
int aaa = 0;
void dfs(int v, int x, int c, int p)
{
    if (used[v])
    {
        return;
    }
    //cout<<v<<' '<<x<<endl;
    used[v] = c;
    xo[v] = x;
    for(auto el:A[v])
    {
        int w = el.first;
        int val = zar[el.second];
        if (el.second != p && used[w])
        {
            //cout<<v<<' '<<w<<' '<<x<<endl;
            if ((xo[w] ^ xo[v]) ^ 1 != val)
            {
                aaa = 1;
            }
        }
        else
        {
            dfs(w, x ^ val, c, el.second);
        }
    }
}
int getp(int v)
{
    if (v != used[v])
    {
        used[v] = getp(used[v]);
    }
    return used[v];
}

void unite(int u, int v)
{
    u = getp(u);
    v = getp(v);
    if (rand()%2)
    {
        used[u] = v;
    }
    else
    {
        used[v] = u;
    }
}

vector<int> tin, f;
int t = 0;
//vector<int> edg;
void dfs2(int v, int p)
{
    if (used[v])
    {
        return;
    }
    used[v] = 1;
    tin[v] = t++;
    f[v] = tin[v];
    for(auto el:A[v])
    {
        int w = el.first;
        int val = zar[el.second];
        if (el.second == p)
        {
            continue;
        }
        if (used[w])
        {
            f[v] = min(f[v], tin[v]);
        }
        else
        {
            dfs2(w, el.second);
            f[v] = min(f[v], f[w]);
        }

    }
}

main()
{
    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int N, M;
    cin>>N>>M;
    A.resize(N);
    used.resize(N);
    xo.resize(N);
    zar.resize(N);
    vector<pair<int, int> > edges;
    for(int i = 0; i < M; ++ i)
    {
        int a, b;
        cin>>a>>b;
        a--;
        b--;
        char c;
        cin>>c;
        int val = 0;
        if (c == '-')
        {
            val = 1;
        }
        if (c != '?')
        {
            A[a].push_back({b, i});
            A[b].push_back({a, i});
            zar[i] = val;
        }
        else
        {
            edges.push_back({a, b});
        }
    }
    long long mod = 1e18;
    mod -= 1;
    mod /= 9;
    //cout<<mod<<endl;
    //int cnt = 1;
    for(int i = 0; i < N; ++i)
    {
        if (used[i] == 0)
        {
            dfs(i, 0, i + 1, -1);
        }
    }
    if (aaa)
    {
        cout<<0<<endl;
        return 0;
    }
    for(int i = 0; i < N; ++i)
    {
        used[i]--;
        //cout<<used[i]<<' ';
    }
    long long cnt = 1;
    int cur = M;
    for(auto edge:edges)
    {
        int a = edge.first;
        int b = edge.second;
        int aa = getp(a);
        int bb = getp(b);
        //cout<<a<<' '<<b<<' '<<aa<<' '<<bb<<endl;
        if (aa != bb)
        {
            cnt *= 2LL;
            cnt %= mod;
        }
        unite(aa, bb);
        A[a].push_back({b, cur});
        A[b].push_back({a, cur});
        cur++;
    }
    used.assign(N, 0);
    tin.assign(N, 0);
    f.assign(N, 0);
    for(int v = 0; v < N; ++v)
    {
        if (!used[v])
        {
            dfs2(v, -1);
        }
    }
    for(auto edge:edges)
    {
        int a = edge.first;
        int b = edge.second;
        //cout<<a<<' '<<b<<' '<<f[a]<<' '<<f[b]<<endl;
        if (tin[a] > tin[b])
        {
            swap(a, b);
        }
        if (f[b] > f[a])
        {
            cout<<0<<endl;
            return 0;
        }
    }
    cout<<cnt<<endl;
}
