#include <bits/stdc++.h>

using namespace std;

#define int long long

const int maxw = 2e5 + 5;

int primes[maxw];
char used[maxw];

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    for (int i = 1; i < maxw; ++i) {
        primes[i] = 1;
    }
    for (int i = 2; i < maxw; ++i) {
        if (used[i]) continue;
        for (int j = i; j < maxw; j += i) {
            used[j] = true;
            int t = j;
            while (t % (i * i) == 0) t /= i * i;
            if (t % i == 0) primes[j] *= i;
        }
    }

    map<int, int> d;
    int n; cin >> n;
    for (int i = 0; i < n; ++i) {
        int x; cin >> x;
        d[primes[x]] += 1;
    }
    int ans = 0;
    for (auto p: d) {
        int k = p.second;
        ans += k * (k - 1) / 2;
    }
    cout << ans << endl;
}
