#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<int> sorted(int n) {
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[i] = i;
    }
    return ans;
}

vector<int> mult(const vector<int> &a, const vector<int> &b) {
    int n = a.size();
    vector<int> c(n);
    for (int i = 0; i < n; ++i) {
        c[i] = b[a[i]];
    }
    return c;
}

vector<int> power(const vector<int> &a, int p) {
    if (p == 0) return sorted(a.size());
    if (p & 1) return mult(a, power(a, p - 1));
    return power(mult(a, a), p >> 1);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    int n, m, k;
    cin >> n >> m >> k;
    vector<int> rest = sorted(n);
    vector<int> cur = sorted(n);
    for (int i = 1; i <= m; ++i) {
        int a, b; cin >> a >> b;
        --a; --b;
        swap(cur[a], cur[b]);
        if (k % m == i) rest = cur;
    }

    vector<int> ans = mult(rest, power(cur, k / m));
    for (int i = 0; i < n; ++i) {
        cout << ans[i] + 1 << ' ';
    }
}

