#include <bits/stdc++.h>

using namespace std;

typedef long double ftype;
typedef complex<ftype> point;
#define x real
#define y imag

const double inf = 1e9, eps = 1e-12;
const ftype pi = acos(-1.);

bool check(vector<point> a, vector<point> b, point r)
{
    int n = a.size();
    for(auto &it: b)
        it *= r;
    auto cmp = [](point a, point b){return make_pair(a.x(), a.y()) < make_pair(b.x(), b.y());};
    sort(begin(a), end(a), cmp);
    sort(begin(b), end(b), cmp);
    for(int i = 0; i < n; i++)
        if(abs(a[i] - b[i]) > eps)
            return 0;
    return 1;
}

signed main()
{
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<point> r[2];
    ftype x, y;
    point mid[2] = {0};
    for(int z = 0; z <= 1; z++)
    for(int i = 0; i < n; i++)
    {
        cin >> x >> y;
        r[z].emplace_back(x, y);
        mid[z] += r[z][i] / (ftype)n;
    }
    for(int i = 0; i < n; i++)
    {
        r[0][i] -= mid[0];
        r[1][i] -= mid[1];
    }
    int ptr = 0;
    while(ptr < n && abs(r[0][ptr]) < eps)
        ptr++;
    if(ptr == n)
    {
        cout << 0 << endl;
        return 0;
    }
    ftype ans = 2 * pi;
    for(int i = 0; i < n; i++)
    {
        if(abs(r[1][i]) < eps)
            continue;
        if(abs(abs(r[0][ptr]) - abs(r[1][i])) > eps)
            continue;
        point rot = r[0][ptr] / r[1][i];
        if(check(r[0], r[1], rot))
            ans = min(ans, abs(arg(rot)));
    }
    cout << fixed << setprecision(10) << ans << endl;
}
