#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <vector>
#include <cstdlib>
#include <string>
#include <sstream>
#include <algorithm>
#include <map>

using namespace std;

const int N = 2e5 + 100;

int max_div[N];

typedef long long ll;

vector<int> get_vector(int n) {
	map<int, int> T;
	while (n > 1) {
		int diver = max_div[n];
		n /= diver;
		T[diver]++;
	}
	vector<int> res;
	for (auto el : T) {
		if (el.second & 1) {
			res.push_back(el.first);
		}
	}
	return res;
}

map<vector<int>, ll> M;

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	max_div[1] = -1;
	for (int i = 2; i < N; i++) {
		if (max_div[i] != 0) continue;
		for (int j = i * 2; j < N; j += i) {
			max_div[j] = i;
		}
		max_div[i] = i;
	}

	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int s;
		cin >> s;
		vector<int> v = get_vector(s);
		M[v]++;
	}

	ll ans = 0;
	for (auto el : M) {
		ans += el.second * (el.second - 1) / 2;
	}

	cout << ans;

	return 0;
}