#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <vector>
#include <cstdlib>
#include <string>
#include <sstream>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;

vector<ll> get_divs(ll x) {
	vector<ll> res;
	for (ll i = 1; i * i <= x; i++) {
		if (x % i == 0) {
			res.push_back(i);
			res.push_back(x / i);
		}
	}
	return res;
}

vector<int> ans;

int a, b;
ll a1;
ll a2;

void check(ll d) {
	if (a % d == a1 && a % (d * d) == a1 + a2 * d) {
		ans.push_back(d);
	}
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> a >> b;
	a1 = b % 10;
	a2 = b / 10;
	check(68);
	if (a <= b) {
		for (int i = 2; i <= a; i++) {
			check(i);
		}
	}
	else {
		int u = a - a1;
		auto v = get_divs(u);
		vector<int> ans;

		for (auto d : v) {
			check(d);
		}
	}
	if (ans.empty()) {
		cout << -1;
		return 0;
	}
	sort(ans.begin(), ans.end());
	ans.resize(unique(ans.begin(), ans.end()) - ans.begin());
	for (auto el : ans) cout << el << " ";

	return 0;
}