#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <vector>
#include <cstdlib>
#include <string>
#include <sstream>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;

bool check_square(int a, int b) {
	return a == b;
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int ans = 0;
	ll w, h;
	cin >> w >> h;
	
	//не проводим линий
	if (w == h) {
		ans = max(ans, 1);
	}

	//проводим одну линию
	//обрезаем меньшую сторону, делаем один квадрат
	ans = max(ans, 1);
	//делаем два квадрата, должна быть одинаковая ширина и высота
	if ((check_square(w / 2, h) && check_square(w - w / 2, h)) || 
		(check_square(w, h / 2) && check_square(w, h - h / 2))) {
		ans = max(ans, 2);
	}

	
	//проводим ровно две линии
	
	//проводим по одной стороне - это должна быть большая сторона
	if (w < h) swap(w, h);
	if (w == 3 * h) {
		ans = max(ans, 3);
	}
	if (w >= h * 2) {
		ans = max(ans, 2);
	}

	//проводим по разным линиям
	
	//пытаемся получить два квадрата
	if (w % 2 == 0 || h % 2 == 0) {
		//рубим большую пополам, у меньшей отсекаем часть
		ans = max(ans, 2);
	}
	if (w % 2 == 0 && h % 2 == 0) {
		if (check_square(w / 2, h / 2)) {
			ans = max(ans, 4);
		}
	}
	cout << ans;

	return 0;
}