#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>

using namespace std;

typedef long long ll;

const int NUM = 4e5 + 100;

int main() {	
	//freopen("input.txt", "r", stdin);

	int n;
	cin >> n;

	vector<ll> v(n);
	vector<ll> cnt(NUM);
	ll ans = 0;
	ll nsq = 0;
	for (int i = 0; i < v.size(); ++i) {
		cin >> v[i];

		ll num = v[i];
		vector<ll> prs;
		for (ll j = 2; j * j <= num; ++j) {
			ll cnt = 0;
			while (num % j == 0) {
				num /= j;
				++cnt;
			}
			if (cnt % 2 == 1) {
				prs.push_back(j);
			}
		}
		if (num != 1LL) {
			prs.push_back(num);
		}

		if ((int)prs.size() == 0) {
			++nsq;
		}
		else {
			ll pr = 1;
			for (int j = 0; j < prs.size(); ++j) {
				pr *= prs[j];
			}
			++cnt[pr];
		}
	}	

	if (nsq >= 2LL) {
		ans += (nsq * (nsq - 1)) / 2LL;
	}

	for (int i = 0; i < cnt.size(); ++i) {
		if (cnt[i] >= 2) {
			ans += (cnt[i] * (cnt[i] - 1LL)) / 2LL;
		}
	}

	cout << ans;

	return 0;
}