#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>

using namespace std;

typedef long long ll;

const int NUM = 4e5 + 100;

int main() {	
	freopen("input.txt", "r", stdin);

	int n;
	scanf("%d", &n);

	vector<ll> v(n);
	vector<ll> cnt(NUM);
	ll ans = 0;
	ll nsq = 0;
	for (int i = 0; i < v.size(); ++i) {
		scanf("%d", &v[i]);

		ll num = v[i];
		ll pr = 1LL;
		for (ll j = 2; j * j <= num; ++j) {
			ll cnt = 0;
			if (num == 1) {
				break;
			}
			while (num % j == 0) {
				num /= j;
				++cnt;
			}
			if (cnt % 2 == 1) {
				pr *= j;
			}
		}
		if (num != 1LL) {
			pr *= num;
		}

		if (pr == 1) {
			++nsq;
		}
		else {
			++cnt[pr];
		}
	}	

	if (nsq >= 2LL) {
		ans += (nsq * (nsq - 1)) / 2LL;
	}

	for (int i = 0; i < cnt.size(); ++i) {
		if (cnt[i] >= 2) {
			ans += (cnt[i] * (cnt[i] - 1LL)) / 2LL;
		}
	}

	cout << ans;

	return 0;
}