#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const int NUM = 2e5 + 100;

int main() {	
	freopen("input.txt", "r", stdin);

	int n;
	scanf("%d", &n);

	vector<ll> v(n);
	vector<ll> cnt(NUM);
	ll ans = 0;
	ll nsq = 0;

	vector<ll> dd(NUM, -1);
	for (int ii = 2; ii < NUM; ++ii) {
		if (dd[ii] != -1) {
			continue;
		}
		for (int j = ii + ii; j < NUM; j += ii) {
			dd[j] = ii;
		}
	}

	for (int i = 0; i < v.size(); ++i) {
		scanf("%d", &v[i]);
		
		if (v[i] == 1) {
			++nsq;
			continue;
		}

		if (dd[v[i]] == -1) {
			++cnt[v[i]];
			continue;
		}

		map<ll, ll> M;
		ll num = v[i];
		while (num != 1) {
			M[dd[num]]++;
			num /= dd[num];
			if (dd[num] == -1) {
				M[num]++;
				break;
			}
		}

		ll pr = 1;
		for (auto it = M.begin(); it != M.end(); ++it) {
			if (it->second % 2 == 1) {
				pr *= it->first;
			}
		}

		if (pr == 1) {
			++nsq;
		}
		else {
			++cnt[pr];
		}
	}	

	if (nsq >= 2LL) {
		ans += (nsq * (nsq - 1)) / 2LL;
	}

	for (int i = 0; i < cnt.size(); ++i) {
		if (cnt[i] >= 2) {
			ans += (cnt[i] * (cnt[i] - 1LL)) / 2LL;
		}
	}

	cout << ans;

	return 0;
}