#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>

using namespace std;

typedef long long ll;
#define mp make_pair

vector<vector<string>> res;
int max_size_arr = 0;

void handle_s(string s) {
	bool flag_into = false;
	string cur_str = "";
	vector<string> cur_arr_str;
	int slen = s.size();
	for (int i = 0; i < s.size(); ++i) {
		if (!flag_into && s[i] == ',') {
			cur_arr_str.push_back(cur_str);
			cur_str = "";
			continue;
		}
		if (s[i] == '"') {
			if (!flag_into) {
				flag_into = true;
				continue;
			}
			else {
				if (i + 1 == slen) {
					flag_into = false;
					continue;
				}
				if (s[i + 1] == '"') {
					cur_str += '"';
					++i;
					continue;
				}
				else {
					assert(s[i + 1] == ',');
					flag_into = false;
					continue;
				}
			}
		}
		else {
			cur_str += s[i];
		}
	}
	cur_arr_str.push_back(cur_str);
	cur_str = "";
	max_size_arr = max(max_size_arr, (int)cur_arr_str.size());
	res.push_back(cur_arr_str);
}

vector<int> mlen;
void count_max_len() {
	mlen.resize(max_size_arr, 0);
	for (int i = 0; i < res.size(); ++i) {
		for (int j = 0; j < res[i].size(); ++j) {
			int len = res[i][j].size();
			mlen[j] = max(mlen[j], len);
		}
	}
}

void cout_space(int num) {
	for (int i = 0; i < num; ++i) {
		cout << ' ';
	}
}

int main() {	
	freopen("input.txt", "r", stdin);

	string s;
	while (getline(cin, s)) {
		handle_s(s);
	}
	count_max_len();

	for (int i = 0; i < res.size(); ++i) {
		for (int j = 0; j < max_size_arr; ++j) {
			if (j >= (int)res[i].size()) {
				cout_space(mlen[j]);
			}
			else {
				int rest = mlen[j] - (int)res[i][j].size();
				cout << res[i][j];
				cout_space(rest);
			}
			if (j != max_size_arr - 1) {
				cout << '|';
			}
		}
		cout << '\n';
	}

	return 0;
}