#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>

using namespace std;

typedef long long ll;

ll a, b;
ll A, B;

set<ll> ans;

void init_ab() {
	a = B / 10;
	b = B % 10;
}

void case_0() {
	if (A < b) {
		return;
	}
	if ((A - b) % a == 0) {
		ll k = (A - b) / a;
		if (a < k && b < k) {
			ans.insert((A - b) / a);
		}
	}
}

int main() {	
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> A >> B;
	/*if (A == 1 && B != 1) {
		cout << -1;
		return 0;
	}
	else if (A == 1 && B == 1) {
		cout << 1;
		return 0;
	}*/

	init_ab();

	case_0();
	
	for (ll k = 2; k*k + k*a + b <= A; ++k) {
		if (a >= k || b >= k) {
			continue;
		}
		if ((A - k*a - b) % (k*k) == 0) {
			ans.insert(k);
			continue;
		}
	}

	if ((int)ans.size() == 0) {
		cout << -1;
	}
	else {
		for (auto it = ans.begin(); it != ans.end(); ++it) {
			cout << *it << ' ';
		}
	}

	return 0;
}