#include <cstdio>
#include <iostream>
#include <cmath>
#include <string>
#include <vector>

#define ll long long
#define forl(i,n) for(ll i = 0; i < n;++i)

using namespace std;

int main()
{
#ifdef VALERA_DBG
	freopen("in.txt","r",stdin);
	freopen("out.txt","w",stdout);
#endif

	ll a, b, b0, b1;
	ll maxd = 0;
	cin >> a >> b;

	b0 = b % 10;
	b1 = b / 10;
	maxd = max(b0,b1);
	vector<ll> ans;

	ll cur = a - b0;
	if (cur % b1 == 0)
	{
		cur = cur / b1;
		if(cur > maxd)
			ans.push_back(cur);
	}

	cur = a - b0;
	for(ll i = 2; i * i <= cur; ++i)
	{
		ll cur1 = (a - b0) % (i * i);
		if (cur1 % b1 == 0)
		{
			cur1 = cur1 / b1;
			if(cur1 > maxd && cur1 == i)
				ans.push_back(cur1);
		}
	}

	if(ans.size() == 0)
		cout << -1 << endl;
	else
	{
		ll S = ans.size();
		forl(i,S)
			cout << ans[i] << " ";
		cout << endl;
	}
	return 0;
}