#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double ld;

vector<int> operator*(const vector<int>& a, const vector<int>& b)
{
    int n = sz(a);
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[i] = a[b[i]];
    }
    return ans;
}

vector<int> binpow(vector<int> a, ll k)
{
    int n = sz(a);
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[i] = i;
    }
    while (k) {
        if (k & 1) {
            ans = ans * a;
        }
        k >>= 1;
        a = a * a;
    }
    return ans;
}

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //ifstream cin("input.txt");

    int n;
    cin >> n;
    int m;
    cin >> m;

    ll k;
    cin >> k;

    vector<int> a(m), b(m);
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }

    for (int i = 0; i < m; ++i) {
        cin >> a[i] >> b[i];
        --a[i], --b[i];
        swap(p[a[i]], p[b[i]]);
    }

    ll z = k / m;
    vector<int> ans = binpow(p, z);
    ll r = k % m;
    for (int i = 0; i < r; ++i) {
        swap(ans[a[i]], ans[b[i]]);
    }

    for (int i = 0; i < n; ++i) {
        cout << ans[i] + 1 << " ";
    }
    cout << "\n";

}
