#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <cstring>
#include <ctime>
#include <cassert>
#include <memory.h>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <complex>
#include <bitset>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e5);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-7;
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)0)++)

void solve()
{
	int a, b;
	cin >> a >> b;
	int db = b % 10;
	int da = b / 10;
	vector<int> ans;
	int pos = a;
	for (int dv = 2; pos >= 200000; dv++)
	{
		//cerr << pos << '\n';
		int npos = (a / dv);
		for (int i = 0; i <= 10; i++)
		{
			int tt = pos - i;
			if (tt <= npos)
				break;
			if ((a % tt) == db && ((a / tt) % tt) == da)
			{
				ans.push_back(tt);
			}
		}
		pos = npos;
	}

	for (int i = 2; i <= 200000; i++)
	{
		if (((a % i) == db) && ((a / i) % i) == da)
		{
			ans.push_back(i);
		}
	}

	sort(ans.begin(), ans.end());
	ans.resize(unique(ans.begin(), ans.end()) - ans.begin());
	if (ans.empty())
		cout << "-1";
	else
	{
		for (int i = 0; i < (int)ans.size(); i++)
			cout << ans[i] << ' ';
	}
}

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
#endif

	solve();

	return 0;
}