#include <iostream>
#include <string>
#include <map>
using namespace std;

bool prime(long long n)
{
	for (long long i = 2; i * i <= n; ++i)
		if (n % i == 0) return 0;
	return 1;
}

long long primes[90];

long long S[200010];
long long res[200011];

int main()
{
	int d = 0;
	for (long long k = 2; k * k <= 200000; ++k)
		if (prime(k))
		{
			primes[d] = k;
			++d;
		}
	//cout << d;

	long long N;
	cin >> N;
	for (long long i = 0; i < N; ++i)
	{
		cin >> S[i];
		for (int j = 0; j < d; ++j)
		{
			while ((S[i] % (primes[j] * primes[j])) == 0)
				S[i] /= (primes[j] * primes[j]);
		}
		++res[S[i]];
	}
	long long ans = 0;
	for (int i = 1; i <= 200000; ++i)
		if (res[i] > 1)
			ans += res[i] * (res[i] - 1) / 2;

	cout << ans << endl;

	return 0;

}