#include <iostream>
#include <string>
#include <map>
#include <algorithm>
using namespace std;

int T[100001][1000];
int A[100001], B[100001];

int main()
{

	long long n, m, k;
	cin >> n >> m >> k;
	int row_before[1000];
	for (int i = 0; i < n; ++i)
	{
		T[0][i] = i; row_before[i] = i;
	}

	for (int j = 1; j <= m; ++j)
	{
		int a, b;
		cin >> a >> b;
		--a; --b;
		A[j - 1] = a; B[j - 1] = b;
		for (int i = 0; i < n; ++i)
			T[j][i] = T[j-1][i];
		swap(T[j][a], T[j][b]);
	}

	int k1, k2;
	k1 = k / m; k2 = k - m * k1;
	for (int j = 0; j < k1; ++j)
	{
		int row_new[1000];
		for (int i = 0; i < n; ++i)
		{
			row_new[i] = T[m][row_before[i]];
		}
		for (int i = 0; i < n; ++i)
		{
			row_before[i] = row_new[i];
		}
	}


	int row_after[1000];
	for (int i = 0; i < n; ++i)
	{
		row_after[i] = row_before[i];
	}
	for (int j = 0; j < k2; ++j)
	{
		swap(row_after[A[j]], row_after[B[j]]);
	}

	for (int i = 0; i < n; ++i)
	{
		cout << row_after[i] + 1 << " ";
	}
	cout << endl;



	return 0;

}