#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <memory.h>
#include <fstream>
#include <sstream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long int64;

int get(int x)
{
	int q = x;
	int res = 1;
	for (int i = 2; i * i <= x; i++)
	{
		if (q % i == 0)
		{
			int cnt = 0;
			while (q % i == 0)
			{
				++cnt;
				q /= i;
			}
			if (cnt & 1)
			{
				res *= i;
			}
		}
	}
	if (q)
	{
		res *= q;
	}
	//cerr << x << " " << res << endl;
	return res;
}

const int MAXN = 200500;

int c[MAXN];

void solve()
{
	int n;
	scanf ("%d", &n);
	for (int i  = 1; i <= n; i++)
	{
		int s; scanf ("%d", &s);
		c[get(s)]++;
	}
	int64 ans = 0LL;
	for (int i = 1; i < MAXN; i++)
	{
		ans += (int64)c[i] * (c[i] - 1) / 2;
	}
	printf("%lld\n", ans);
}

int main()
{
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

	srand(33);
	solve();

	return 0;
}