#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cassert>
#include <sstream>
#include <cstdio>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <functional>
#include <map>
#include <sstream>
#include <utility>
using namespace std;
#define Sz(x) ((int)((x).size()))
typedef long long int64;
typedef pair<int, int> pii;

int n, m;
std::vector<pii> swaps;

const int maxn = 1010;

int pos[maxn];
int cur[maxn];
int tmp[maxn];
int id[maxn];

void apply(int a[maxn], int p[maxn]) {
	for (int i = 0; i < maxn; ++i)
		tmp[i] = a[p[i]];
	memcpy(a, tmp, sizeof(tmp));
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	for (int i = 0; i < maxn; ++i) {
		pos[i] = i;
		cur[i] = i;
		id[i] = i;
	}

	int64 k;
	cin >> n >> m >> k;
	for (int i = 0; i < m; ++i) {
		int a, b; cin >> a >> b;
		swaps.push_back(pii(a, b));
		swap(pos[a], pos[b]);
	}

	for (int64 km = k / m; km; km >>= 1) {
		if (km & 1) {
			apply(cur, pos);
		}
		apply(pos, pos);
	}

	int ost = k % m;
	for (int i = 0; i < ost; ++i)
		swap(cur[swaps[i].first], cur[swaps[i].second]);
	
	for (int i = 1; i <= n; ++i)
		cout << cur[i] << ' ';
	cout << endl;
	
	return 0;
}