#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cassert>
#include <sstream>
#include <cstdio>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <functional>
#include <map>
#include <set>
#include <sstream>
#include <utility>
#include <cstring>
#include <cstdlib>
#include <unordered_set>
using namespace std;
#define Sz(x) ((int)((x).size()))
typedef long long int64;
typedef pair<int, int> pii;

const int maxn = 10000;
int ans[maxn];
int used[maxn];
int gooddiff = 0;

void go(int pos) {
	for (int i = 1; ; ++i) {
		bool ok = true;
		int faildiff = 0;
		unordered_set<int> diffs;
		for (int j = 0; j < pos; ++j) {
			if (ans[j] == i) {
				ok = false;
				break;
			}
			int diff = abs(i - ans[j]);
			if (diffs.count(diff))
				++faildiff;
			else
				diffs.insert(diff);
		}
			
	}
}

inline int myrand() {
	unsigned l = rand() & 0xffff;
	unsigned h = rand() & 0xffff;
	return ((h << 16) | l) % 1000000001;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n; cin >> n;

	for (int it = 0; ; ++it) {
		srand(0);
		for (int i = 0; i < n; ++i) ans[i] = myrand();

		if (n > 100)
			break;

		int good = 0, bad = 0;
		unordered_set<int> diffs;
		for (int i = 0; i < n; ++i)
			for (int j = i + 1; j < n; ++j) {
				const int d = abs(ans[i] - ans[j]);
				if (diffs.count(d))
					++bad;
				else {
					++good;
					diffs.insert(d);
				}
			}
		if (double(bad) / (good + bad) < 0.099)
			break;
		//fprintf(stderr, "%.10lf\n", );
	}

#if 1
	for (int i = 0; i < n; ++i)
		cout << ans[i] << ' ';
	cout << endl;
#endif

	return 0;
}