#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cassert>
#include <sstream>
#include <cstdio>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <functional>
#include <map>
#include <set>
#include <sstream>
#include <utility>
#include <cstring>
#include <cstdlib>
using namespace std;
#define Sz(x) ((int)((x).size()))
typedef long long int64;
typedef pair<int, int> pii;

const int maxs = 100500;
const int block_size = 300;
const int bcount = maxs / block_size + 1;

char values[maxs];
//int ones[bcount];


set<pii> ones;
int ans = 0;

void merge(int from, int to) {
	auto it = ones.lower_bound(pii(from, to));
	assert(it != ones.end() && it->first == from && it->second == to);

	auto nit = it;
	++nit;
	if (nit != ones.end() && nit->first == to) {
		ones.erase(it);
		to = nit->second;
		ones.erase(nit);

		it = ones.insert(pii(from, to)).first;
	}

	if (it != ones.begin()) {
		auto pit = it;
		--pit;
		if (pit->second == from) {
			ones.erase(it);
			from = pit->first;
			ones.erase(pit);
			ones.insert(pii(from, to));
		}
	}
}

void add_inter(int from, int to) {
	if (to <= from)
		return;
	ones.insert(pii(from, to));
	ans += to - from;
	merge(from, to);
}

void add(int pos) {
	if (ones.empty()) {
		add_inter(pos, pos + 1);
		return;
	}

	auto it = ones.lower_bound(pii(pos, pos));
	if (it == ones.end() || (it != ones.begin() && it->first > pos))
		--it;

	// set into
	if (it->first <= pos && pos < it->second) {
		int from = it->first;
		int to = it->second;
		ones.erase(it);
		ans -= to - from;

		add_inter(from, pos);
		add_inter(to, to + 1);
		
	} // set outto
	else {
		add_inter(pos, pos + 1);
	}
}

void sub(int pos) {
	assert(!ones.empty());
	auto it = ones.lower_bound(pii(pos, pos));
	if (it == ones.end() || (it != ones.begin() && it->first > pos))
		--it;

	// set into
	if (it->first <= pos && pos < it->second) {
		int from = it->first;
		int to = it->second;
		ones.erase(it);
		ans -= to - from;

		add_inter(from, pos);
		add_inter(pos + 1, to);

	} // set outto
	else {
		it = ones.lower_bound(pii(pos, pos));
		assert(it != ones.end() && it->first > pos);

		int from = it->first;
		int to = it->second;

		ones.erase(it);
		ans -= to - from;
		add_inter(pos, from);
		add_inter(from + 1, to);
	}
}

void solve_vitalyi() {
	int n; scanf("%d", &n);
	char buf[20];
	int pos;
	for (int i = 0; i < n; ++i) {
		scanf("%s %d", buf, &pos);

		if (!strcmp(buf, "add"))
			add(pos);
		else if (!strcmp(buf, "sub"))
			sub(pos);
		printf("%d\n", ans);
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

#if 0
	int a, b; cin >> a >> b;

	assert(10 <= b && b < 100);
	int b0 = b % 10;
	int b1 = b / 10;

	for (int i = 2; i < 100; ++i) {
		if (a % i != b0)
			continue;
		if (a / i % i != b1)
			continue;
		cout << i << ' ';
	}
	for (int i = 10; i < 100; ++i)
		if (a % i == b)
			cout << i << ' ';
	
	cout << endl;


	for (int h = 1; h <= 10; ++h)
		for (int w = h; w <= 10; ++w) {
			cout << "h=" << h << " , w=" << w << "   res = " << fullsolve(w, h) << endl;
		}
	return 0;
#endif

	solve_vitalyi();

	return 0;
}