#define _CRT_SECURE_NO_WARNINGS

#include <cstdlib>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iostream>

using namespace std;

typedef long long ll;

int main()
{
#ifndef XXX
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n;
	cin >> n;
	vector <int> a(n);
	vector < int > g;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		int x = a[i];
		int temp = 1;
		for (int j = 2; j * j <= a[i]; j++)
		{
			int res = 0;
			while (a[i] % j == 0)
			{
				a[i] /= j;
				res++;
			}
			res %= 2;
			if (res)
				temp *= j;
		}
		if (a[i] != 1)
			temp *= a[i];
		g.push_back(temp);
	}

	sort(g.begin(), g.end());

	ll answer = 0;
	for (int i = 0; i < n;)
	{
		ll k = 0;
		while (i + k < n && g[i] == g[i + k])
		{
			k++;
		}
		i += k;
		answer += (k * (k - 1) / 2);
	}
	cout << answer;
	return 0;
}