#define _CRT_SECURE_NO_WARNINGS

#include <cstdlib>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iostream>

using namespace std;

typedef long long ll;

string g[200][200];
int maxlen[200];

set < int > S;
vector <pair<int, int> > ps;

void rec(int pos, int ch)
{
	if (pos >= ps.size())
		return;
	for (int k = 0; k < ps[pos].second; k++)
	{
		ch *= ps[pos].first;
		S.insert(ch);
		rec(pos + 1, ch);
	}
}

int main()
{
#ifdef XXX
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ll a, b;
	cin >> a >> b;
	
	int cur = a - b % 10;
	
	for (int i = 2; i * i <= cur; i++)
	{
		int res = 0;
		while (cur % i == 0)
		{
			res++;
			cur /= i;
		}
		if (res)
			ps.push_back(make_pair(i, res));
	}
	if (cur > 1)
		ps.push_back(make_pair(cur, 1));

	rec(0, 1);

	vector <int> ans;
	for (auto x : S)
	{
		if ((a % (x*x)) == ((b / 10)*x + (b % 10))) {
			ans.push_back(x);
		}
	}
	
	if (ans.size() == 0)
		cout << -1;
	
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i] << " ";

	return 0;
}