#include <iostream>
#include <vector>
#include <map>
#include <cstdio>
#define int long long int

using namespace std;

vector<int> apply(vector<int>&p, vector<int>&cur)
{
    vector<int> ans(cur.size());
    int N = cur.size();
    for(int i = 0; i < N; ++i)
    {
        ans[i] = p[cur[i]];
        //cout<<i<<' '<<ans[i]<<endl;
    }
    return ans;
}

main()
{
    freopen("input.txt", "r", stdin);
    int N, M, K;
    cin>>N>>M>>K;
    int log = 62;
    vector<vector<int> > permut(log, vector<int>(N));
    vector<pair<int, int> > swaps(M);
    for(int i = 0; i < N; ++i)
    {
        permut[0][i] = i;
    }
    for(int i = 0; i < M; ++i)
    {
        int a, b;
        cin>>a>>b;
        a--;
        b--;
        swaps[i] = make_pair(a, b);
        swap(permut[0][a], permut[0][b]);
    }
    //cout<<N<<endl;

    for(int k = 1; k < log; ++k)
    {
        for(int i = 0; i < N; ++i)
        {
            permut[k][i] = permut[k-1][permut[k-1][i]];
        }
    }
    int whole = K / M;
    vector<int> A(N);
    for(int i = 0; i < N; ++i)
    {
        A[i] = i;
    }
    int k = 0;
    while(whole > 0)
    {
        if (whole % 2)
        {
            A = apply(permut[k], A);
        }
        whole /= 2;
        k++;
    }
    int rem = K % M;
    for(int i = 0; i < rem; ++i)
    {
        int a = swaps[i].first;
        int b = swaps[i].second;
        swap(A[a], A[b]);
    }
    for(auto el:A)
    {
        cout<<el+1<<' ';
    }
    cout<<endl;
}
