#include <iostream>
#include <vector>
#include <map>
#include <cstdio>
//#define int long long int

using namespace std;
int inf = 1179179179;
struct node
{
    int sum;
    vector<int> last;
    int add;
    node()
    {
        sum = 0;
        last.resize(2);
        last[0] = inf;
        last[1] = inf;
        add = -1;
    }
    node(int a, int b, int c)
    {
        sum = a;
        last.resize(2);
        last[0] = a;
        last[1] = b;
        add = -1;
    }
};
int MAXN = 2e6;
vector<node> T(4*MAXN);

void push(int i, int l, int r)
{
    if (T[i].add == -1)
    {
        //cout<<"P"<<i<<' '<<T[i].sum<<endl;
        return;
    }
    T[i].sum = T[i].add * (r - l);
    if (T[i].add == 0)
    {
        T[i].last[0] = l;
        T[i].last[1] = inf;
    }
    else
    {
        T[i].last[1] = l;
        T[i].last[0] = inf;
    }
    if (r - l > 1)
    {
        T[2 * i + 1].add = T[i].add;
        T[2 * i + 2].add = T[i].add;
    }
    T[i].add = -1;
    //cout<<"PUSH"<<i<<' '<<T[i].sum<<endl;
}

void upd(int i)
{
    T[i].sum = T[2 * i + 1].sum + T[2 * i + 2].sum;
    for (int t = 0; t < 2; ++t)
    {
        T[i].last[t] = min(T[2 * i + 1].last[t], T[2 * i + 2].last[t]);
    }
    ////////cout<<T[i].last[0]<<endl;

}

void build(int i, int l, int r)
{
    if (r - l == 1)
    {
        T[i].last[0] = l;
        //////cout<<i<<' '<<l<<' '<<r<<' '<<T[i].last[0]<<endl;
        return;
    }
    int m = (r + l) / 2;
    build(2 * i + 1, l, m);
    build(2 * i + 2, m, r);
    upd(i);
}

int getSum(int i, int l, int r, int L, int R)
{
    push(i, l, r);
    ////cout<<i<<' '<<l<<' '<<r<<' '<<L<<' '<<R<<endl;
    if (L <= l && r <= R)
    {
        return T[i].sum;
    }
    int m = (r + l) / 2;
    if (R <= m)
    {
        return getSum(2 * i + 1, l, m, L, R);
    }
    if (L >= m)
    {
        return getSum(2 * i + 2, m, r, L, R);
    }
    return getSum(2 * i + 1, l, m, L, m) + getSum(2 * i + 2, m, r, m, R);
}

int getLast(int i, int l, int r, int L, int R, int who)
{
    push(i, l, r);
    if (L <= l && r <= R)
    {
        return T[i].last[who];
    }
    int m = (r + l) / 2;
    if (R <= m)
    {
        return getLast(2 * i + 1, l, m, L, R, who);
    }
    if (L >= m)
    {
        return getLast(2 * i + 2, m, r, L, R, who);
    }
    return min(getLast(2 * i + 1, l, m, L, m, who), getLast(2 * i + 2, m, r, m, R, who));
}



void change(int i, int l, int r, int L, int R, int val)
{
    push(i, l, r);
    //cout<<i<<' '<<l<<' '<<r<<' '<<L<<' '<<R<<endl;
    if (L <= l && r <= R)
    {
        T[i].add = val;
        return;
    }
    int m = (r + l) / 2;
    if (L < m)
    {
        change(2 * i + 1, l, m, L, min(m, R), val);
    }
    if (R > m)
    {
        change(2 * i + 2, m, r, max(m, L), R, val);
    }
    push(2 * i + 1, l, m);
    push(2 * i + 2, m, r);
    upd(i);
    //cout<<"S"<<i<<' '<<l<<' '<<r<<' '<<T[i].sum<<endl;
}


main()
{
    freopen("input.txt", "r", stdin);
    //////cout<<"LOL"<<endl;
    int N;
    cin>>N;
    build(0, 0, MAXN);
    for(int i = 0; i < N; ++i)
    {

        string s;
        cin>>s;
        int a;
        cin>>a;
        int who;
        if (s[0] == 'a')
        {
            who = 0;
        }
        else
        {
            who = 1;
        }
        //////cout<<who<<' '<<a<<endl;
        int last = getLast(0, 0, MAXN, a, MAXN, who);
        //cout<<"L"<<last<<endl;
        int L = a;
        int R = last;
        //cout<<L<<' '<<R<<endl;
        if (R > L)
        {
            //cout<<"LAL"<<endl;
            change(0, 0, MAXN, L, R, who);
        }
        //////cout<<"LOL"<<endl;
        change(0, 0, MAXN, R, R+1, 1^who);
        ////cout<<"LOL2"<<endl;
        cout<<getSum(0, 0, MAXN, 0, MAXN)<<endl;
    }

}
