#include <bits/stdc++.h>

using namespace std;

const int maxw = 1e9 + 1;

unordered_set<int> d;

bool check(const vector<int> &a) {
    assert(*max_element(a.begin(), a.end()) < maxw);
    int n = a.size();
    int bad = n * (n - 1) / 2 - n * (n - 1) / 2 * 9 / 10;
    d.reserve(1e8);
    d.clear();
    int cnt = 0;
    for (int i = 0; i < n && cnt <= bad; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int tmp = abs(a[i] - a[j]);
            if (d.count(tmp)) ++cnt;
            else d.insert(tmp);
        }
    }
    return cnt <= bad;
}

int randrange(int l, int r) {
    return l + rand() % (r - l);
}

vector<int> gen(int n) {
    vector<int> a;
    int cur = 0;
    int cnt = 15;
    for (int i = 0; a.size() < n; ++i) {
        int block = randrange(900000, 997000);
        for (int j = 0; j < cnt; ++j) {
            a.push_back(cur + rand() % block);
        }
        cur += block;
    }
    a.resize(n);
    return a;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    //freopen("output.txt", "w", stdout);

    /*int n = 10000;
    vector<int> a(n);
    while (!check(a)) {
        cerr << "!" << endl;
        a = gen(n);
    }*/
    int n;
    cin >> n;
    vector<int> a = gen(n);
    for (int i = 0; i < n; ++i) {
        cout << a[i] << ' ';
    }
}

