#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <vector>
#include <cstdlib>
#include <string>
#include <sstream>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;
#define mp make_pair

string cur;

string read_value(int &pos) {
	if (pos >= cur.size()) return string();
	string res = "";
	bool obram = 0;
	if (cur[pos] == '"') {
		obram = 1;
		pos++;
	}
	for (; pos < cur.size(); pos++) {
		if (cur[pos] == '"') {
			//закрывается обрамление
			if (obram && (pos + 1 == cur.size() || cur[pos + 1] == ',')) {
				obram = 0;
				continue;
			}
			//экранированная кавычка
			if (!obram) {
				res += '"';
				continue;
			}
			if (pos + 1 < cur.size() && cur[pos + 1] == '"') {
				pos++;
				res += '"';
			}
			continue;
		}
		if (!obram && cur[pos] == ',') break;
		res += cur[pos];
	}
	if (obram) {

	}
	pos++;
	return res;
}

vector<vector<string>> t;

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int pos = 0;
	int cols = 0;
	while (getline(cin, cur)) {
		pos = 0;
		vector<string> v;
		while (pos < cur.size()) {
			v.push_back(read_value(pos));
		}
		t.push_back(v);
		cols = max(cols, (int)v.size());
	}
	for (int i = 0; i < t.size(); i++) {
		while (t[i].size() < cols) {
			t[i].push_back(string());
		}
	}
	vector<int> width(cols);
	for (int i = 0; i < t.size(); i++) {
		for (int j = 0; j < cols; j++) {
			width[j] = max(width[j], (int)t[i][j].size());
		}
	}
	vector<int> starts(cols);
	starts[0] = 0;
	for (int i = 1; i < cols; i++) {
		starts[i] = 1 + starts[i - 1] + width[i - 1];
	}
	int rows = t.size();
	for (int i = 0; i < rows; i++) {
		for (int j = 0; j < cols; j++) {
			while (t[i][j].size() < width[j]) t[i][j].push_back(' ');
		}
	}
	vector<string> ans;
	ans.resize(rows);
	for (int i = 0; i < rows; i++) {
		ans[i].resize(starts.back() + width.back());
		for (int j = 1; j < cols; j++) {
			ans[i][starts[j] - 1] = '|';
		}
		for (int j = 0; j < cols; j++) {
			string s = t[i][j];
			for (int k = 0; k < s.size(); k++) {
				ans[i][k + starts[j]] = s[k];
			}
		}
	}
	for (int i = 0; i < rows; i++) {
		cout << ans[i];
		cout << endl;
	}

	return 0;
}