#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <vector>
#include <cstdlib>
#include <string>
#include <sstream>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;
#define mp make_pair

vector<int> v;
int n, m;
ll k;
vector<pair<int, int>> t;
vector<int> one_v;

vector<int> make_one_step(const vector<int>& was, const vector<int>& become, const vector<int>& cur) {
	vector<int> res(n);
	vector<int> bb(n), back_cur(n);
	for (int i = 0; i < n; i++) {
		bb[become[i]] = i;
		back_cur[cur[i]] = i;
	}
	for (int i = 0; i < n; i++) {
		//вместо какой будет поставлена эта
		int i_pos_now = bb[i];
		int g = was[i_pos_now];
		res[back_cur[g]] = i;
	}
	return res;
}

vector<int> make_steps(ll cnt, const vector<int>& cur) {
	if (cnt == 0) {
		return cur;
	}
	if (cnt & 1) {
		vector<int> temp = make_one_step(v, one_v, cur);
		return make_steps(cnt - 1, temp);
	}
	vector<int> temp = make_steps(cnt / 2, cur);
	temp = make_one_step(cur, temp, temp);
	return temp;
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> n >> m >> k;
	vector<int> back_v;
	for (int i = 0; i < n; i++) {
		v.push_back(i);
		back_v.push_back(i);
	}
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		t.push_back(mp(a, b));
		swap(v[back_v[a]], v[back_v[b]]);
		swap(back_v[a], back_v[b]);
	}
	one_v = v;
	for (int i = 0; i < n; i++) {
		v[i] = i;
	}
	ll cnt = k / m;
	m = k % m;
	v = make_steps(cnt, v);
	for (int i = 0; i < n; i++) {
		back_v[v[i]] = i;
	}
	for (int i = 0; i < m; i++) {
		int a = t[i].first, b = t[i].second;
		swap(v[back_v[a]], v[back_v[b]]);
		swap(back_v[a], back_v[b]);
	}
	for (auto el : v) cout << el + 1 << " ";

	return 0;
}