#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <vector>
#include <cstdlib>
#include <string>
#include <sstream>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;
#define mp make_pair

double evaluate(vector<int> v) {
	set<int> S;
	for (int i = 0; i < v.size(); i++) {
		for (int j = 0; j < i; j++) {
			S.insert(abs(v[i] - v[j]));
		}
	}
	ll n = v.size();
	double cnt = n * (n - 1) / 2;
	return (double)S.size() / cnt;
}
int MAX = 4000;

vector<int> make_block(ll mx) {
	vector<int> ans;
	ans.push_back(0);
	ans.push_back(1);
	if (ans.size() == MAX) return ans;
	ll cur = 3;
	while (cur <= mx) {
		ll gg = cur + (ll)ans.back() + 1;
		cur = gg;
		if (cur > mx) {
			cur %= (ll)1e9 - 7;
		}
		ans.push_back(cur);
		if (ans.size() == MAX) return ans;
	}
	return ans;
}
int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> MAX;
	vector<int> v = make_block(1e9);
	for (auto el : v) {
		cout << el << " ";
		assert(el >= 0 && el <= 1e9);
	}


	return 0;
}