#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>

using namespace std;

typedef long long ll;

ll a, b;
ll A, B;

set<ll> ans;

void init_ab() {
	a = B / 10;
	b = B % 10;
}

void case_0() {
	if (A < b) {
		return;
	}
	if ((A - b) % a == 0) {
		ans.insert((A - b) / a);
	}
}

int main() {	
	cin >> A >> B;
	init_ab();

	if (A < b) {
		cout << -1;
		return 0;
	}

	case_0();

	for (ll i = 1; i < 10000000; ++i) {
		ll kv = i * i;
		if (kv < a * a) {
			continue;
		}
		if ((kv - a * a) % (4 * (A - b)) == 0) {
			ll t = (kv - a * a) / (4 * (A - b));
			if (i > a && ((i - a) % (2 * t)) == 0) {
				ll k = (i - a) / (2 * t);
				ans.insert(k);
			}
		}
	}

	if (0 == ans.size()) {
		cout << -1;
	}

	for (auto it = ans.begin(); it != ans.end(); ++it) {
		if (*it == 1) {
			continue;
		}
		cout << *it << ' ';
	}

	return 0;
}