#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
#define mp make_pair
typedef vector<vector<int>> Mat;

vector<int> mul(vector<int> a, vector<int> b) {
	vector<int> res(a.size());
	for (int i = 0; i < res.size(); ++i) {
		res[i] = b[a[i]];
	}
	return res;
}

int main() {	
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	ll n, m, k;
	cin >> n >> m >> k;

	vector<int> p1(n);
	for (int i = 0; i < p1.size(); ++i) {
		p1[i] = i + 1;
	}
	vector<int> p2 = p1;
	vector<pair<int,int>> sws;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a;
		--b;
		sws.push_back(mp(a, b));
		swap(p2[a], p2[b]);
	}
	
	vector<int> mm(n);
	for (int i = 0; i < p2.size(); ++i) {
		mm[i] = p2[i] - 1;
	}

	ll power = k / m;
	ll rest = k % m;
	
	vector<int> res(n);
	for (int i = 0; i < res.size(); ++i) {
		res[i] = i;
	}
	while (power) {
		if (power % 2 == 1) {
			res = mul(mm, res);
			--power;
		}
		else {
			power /= 2;
			mm = mul(mm, mm);
		}
	}

	vector<int> fper(n);
	for (int i = 0; i < fper.size(); ++i) {
		fper[i] = res[i] + 1;
	}

	for (int i = 0; i < rest; ++i) {
		swap(fper[sws[i].first], fper[sws[i].second]);
	}
	for (int i = 0; i < fper.size(); ++i) {
		cout << fper[i] << ' ';
	}

	return 0;
}