#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define X first
#define Y second
#define ins insert

typedef long long ll;

const int maxn = (int)2e5 + 5;
const int MX = (int)2e5;
const ll mod = ((ll)1e18 - 1) / 9;

int t[maxn], p[maxn], znak[maxn], in_cyc[maxn];
int n, m;
vector <pair <int, int> > a[maxn];
vector <int > oa[maxn];
ll ans;

ll multi(ll x, ll y) {
    if (y == 0)
        return 0;
    if (y & 1) {
        return (x + multi(x, y - 1)) % mod;
    } else {
        return ((ll)2 * multi(x, y / 2)) % mod;
    }
}

void dfs(int v, int pr, int z, int reb) {
    t[v] = 1;
    p[v] = pr;
    znak[v] = z;
    int to;
    for (int i = 0; i < a[v].size(); ++i) {
        if (i == reb)
            continue;
        to = a[v][i].X;
        if (t[to] == 1) {
            static int x, cmin, cq;
            x = v;
            cmin = 0;
            cq = 0;
            cmin += (a[v][i].Y == -1);
            cq += (a[v][i].Y == 0);
//            cout << "CYCLE:" << endl;
            while (x != to) {
                if (in_cyc[x]) {
//                    cout << "in_cyc" << endl;
                    cout << 0 << endl;
                    exit(0);
                }
                in_cyc[x] = 1;
                cmin += (znak[x] == -1);
                cq += (znak[x] == 0);
//                cout << x << endl;
                x = p[x];
            }
//            cout << "END" << endl;
            if (cmin % 2 == 0 && cq == 0) {
                cout << 0 << endl;
                exit(0);
            }
            if (cq == 0) {
                continue;
            }
            ans = multi(ans, ((ll)1 << (cq - 1)));
        }
    }

    for (int i = 0; i < a[v].size(); ++i) {
        if (i == reb)
            continue;
        to = a[v][i].X;
        if (t[to])
            continue;
        dfs(to, v, a[v][i].Y, oa[v][i]);
    }

    if (!in_cyc[v]) {
        if (z == 0)
            ans = (ans + ans) % mod;
    }
    t[v] = -1;
    return;
}

int main() {
//    freopen("t.in", "r", stdin);
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        static int x, y, z;
        static string typ;
        cin >> x >> y >> typ;
        if (typ == "+")
            z = 1;
        if (typ == "-")
            z = -1;
        if (typ == "?")
            z = 0;
        oa[y].pb((int)a[x].size());
        oa[x].pb((int)a[y].size());
        a[x].pb(mp(y, z));
        a[y].pb(mp(x, z));
    }
    ans = 1;
    memset(t, 0, sizeof t);
    memset(in_cyc, 0, sizeof in_cyc);
    for (int i = 1; i <= n; ++i) {
        if (t[i])
            continue;
        dfs(i, 0, 1, -1);
    }
    cout << ans << endl;
    return 0;
}

