#include <stdio.h>
#include <math.h>
#include <cmath>
#include <set>
#include <string.h>
#include <string>
#include <vector>
#include <algorithm>

// where the hell is abs()?

int abs1(int x)
{
    if (x < 0)
    {
        return -x;
    }
    return x;
}

#define DEBUG 0

typedef long long int LL;

void fix(char* str)
{
    char* p;
    for (int i = 0, l = strlen(str); i < l; ++i)
    {
        if (str[i] == '"')
        {
            str[i] = '\'';
        }
        if (str[i] == ',')
        {
            str[i] = '|';
        }
    }
    /*
    // Убираем обрамленные пустые ячейки
    if (DEBUG) printf("~~~~~0: %s\n", str);
    p = str;
    while (*p != 0)
    {
        if ((*p == '\'' && *(p + 1) == '\'') &&
            ((*(p + 2) == 0 || *(p + 2) == '|')) &&
            ((p == str || *(p - 1) == '|')))
        {
            //printf("Fixing at index %d\n", str - p);
            for (char* q = p; *q != 0; ++q)
            {
                *q = *(q + 2);
            }
        }
        else
        {
            ++p;
        }
    }*/
    // Заменяем парные внутренние кавычки на непарные
    if (DEBUG) printf("~~~~~1: %s\n", str);
    p = str;
    bool isBegin = true;
    bool inQuote = false;
    while (*p != 0)
    {
        if (DEBUG) printf("     -> %s (%s, %s)\n", p, (isBegin ? "begin" : "mid"), (inQuote ? "quote" : "plain"));
        if (*p == '\'')
        {
            if (isBegin)
            {
                if (inQuote)
                {
                    // Такое вообще корректно?
                    *p = '"';
                }
                else
                {
                    *p = '#';
                    isBegin = false;
                    inQuote = true;
                }
            }
            else
            {
                if (inQuote)
                {
                    if (*(p + 1) == '\'')
                    {
                        *p = '#';
                        ++p;
                        *p = '"';
                    }
                    else
                    {
                        *p = '#';
                        isBegin = true;
                        inQuote = false;
                        ++p;
                        continue;
                    }
                }
                else
                {
                    // valid
                    *p = '"';
                }
            }
        }
        else if (*p == '|')
        {
            if (inQuote)
            {
                *p = ',';
            }
            else
            {
                isBegin = true;
            }
        }
        else
        {
            isBegin = false;
        }
        ++p;
    }
        /*
        if (*p == '\'')
        {
            if (!inQuote)
            {
                inQuote = true;
                ++p;
                continue;
            }
            else
            {
                if (*(p + 1) == '\'')
                {
                    *p = '#';
                    ++p;
                    *p = '"';
                    ++p;
                    continue;
                }
                else
                {
                    inQuote = false;
                    ++p;
                    continue;
                }
            }
        }
        else
        {
            ++p;
        }
        */
    /*
    // Разбираемся, где внутренние запятые, где - разделяющие
    if (DEBUG) printf("~~~~~2: %s\n", str);
    p = str;
    while (*p != 0)
    {
        if (*p == '\'')
        {
            char* temp = p;
            //printf("begin at %d\n", str - p);
            ++p;
            while (*p != 0 && *p != '\'')
            {
                //printf("      : %s\n", str);
                if (*p == '|')
                {
                    *p = ',';
                }
                ++p;
            }
            if (*p == 0)
            {
                *temp = '"';
            }
            //printf("end at %d\n", str - p);
        }
        ++p;
    }
    */
    // Убираем все оставшиеся лишние кавычки во всей строке
    //if (DEBUG) printf("~~~~~3: %s\n", str);
    p = str;
    while (*p != 0)
    {
        if (*p == '#')// || *p == '\'')
        {
            for (char* q = p; *q != 0; ++q)
            {
                *q = *(q + 1);
            }
        }
        else
        {
            ++p;
        }
    }
    //printf("~~~~~4: %s\n", str);
}

int main()
{
    //freopen("input.txt", "rt", stdin);
    //freopen("output.txt", "wt", stdout);

    //std::string ans[105][105];
    char ans[105][105][105];
    for (int i = 0; i < 105; ++i)
    {
        for (int j = 0; j < 105; ++j)
        {
            memset(ans[i][j], 0, sizeof(ans[i][j]));
        }
    }
    std::vector<int> maxlen(105);
    int maxItemIndex = 0;
    int strIndex = 0;
    while (true)
    {
        char str[110];
        memset(str, 0, sizeof(str));
        if (gets(str) == NULL)
        {
            break;
        }
        if (DEBUG) printf("Parse : %s\n", str);
        fix(str);
        char* p = str;
        int itemIndex = 0;
        int charIndex = 0;
        while (*p != 0)
        {
            if (*p == '|')
            {
                ++itemIndex;
                maxItemIndex = std::max(maxItemIndex, itemIndex);
                ++p;
                charIndex = 0;
            }
            else
            {
                ans[strIndex][itemIndex][charIndex] = *p;
                ++charIndex;
                maxlen[itemIndex] = std::max(maxlen[itemIndex], charIndex);
                ++p;
            }
        }
        if (DEBUG) printf("Result: %s\n", str);
        if (DEBUG) printf("\n");
        ++strIndex;
    }
    //printf("maxItemIndex = %d\n", maxItemIndex);
    for (int i = 0; i < strIndex; ++i)
    {
        for (int j = 0; j <= maxItemIndex; ++j)
        {
            printf("%-*s", maxlen[j], ans[i][j]);
            if (j != maxItemIndex)
            {
                printf("|");
            }
        }
        if (i != strIndex - 1)
        {
            printf("\n");
        }
    }

    return 0;
}

