#include <bits/stdc++.h>

using namespace std;

vector<int> operator * (const vector<int> &first, const vector<int> &second) {
    vector <int> ans(first.size());
    for (int i = 0; i < first.size(); ++i) {
        ans[i] = first[second[i]];
    }
    return ans;
}

vector<int> PowQuick(vector<int> p, int64_t k) {
    vector<int> ans(p.size());
    for (int i = 0; i < ans.size(); ++i) {
        ans[i] = i;
    }
    while (k) {
        if (k % 2) {
            ans = ans * p;
        }
        p = p * p;
        k/=2;
    }
    return ans;
}

int main()
{
    freopen("input.txt", "r", stdin);
    int64_t n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, int>> quest(m);
    vector<int> permutation(n);
    for (int i = 0; i < n; ++i) {
        permutation[i] = i;
    }
    for (int i = 0; i < m; ++i) {
        cin >> quest[i].first >> quest[i].second;
        --quest[i].first;
        --quest[i].second;
        swap(permutation[quest[i].first], permutation[quest[i].second]);
    }
    permutation = PowQuick(permutation, k / m);
    for (int i = 0; i < k % m; ++i) {
        swap(permutation[quest[i].first], permutation[quest[i].second]);
    }
    for (int i = 0; i < n; ++i) {
        cout << permutation[i] + 1 << ' ';
    }
    cout << endl;
    return 0;
}
